/* UserList.c generated by valac 0.56.17, the Vala compiler
 * generated from UserList.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2024 elementary, Inc. (https://elementary.io)
 */

#include "quick-settings.h"
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <sys/types.h>
#include <gtk/gtk.h>
#include <act/act.h>
#include <glib/gi18n-lib.h>

#define QUICK_SETTINGS_USER_LIST_GUEST_USER_UID ((uid_t) 999)
#define QUICK_SETTINGS_USER_LIST_DM_DBUS_ID "org.freedesktop.DisplayManager"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define QUICK_SETTINGS_TYPE_SEAT_INTERFACE (quick_settings_seat_interface_get_type ())
#define QUICK_SETTINGS_SEAT_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), QUICK_SETTINGS_TYPE_SEAT_INTERFACE, QuickSettingsSeatInterface))
#define QUICK_SETTINGS_IS_SEAT_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), QUICK_SETTINGS_TYPE_SEAT_INTERFACE))
#define QUICK_SETTINGS_SEAT_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), QUICK_SETTINGS_TYPE_SEAT_INTERFACE, QuickSettingsSeatInterfaceIface))

typedef struct _QuickSettingsSeatInterface QuickSettingsSeatInterface;
typedef struct _QuickSettingsSeatInterfaceIface QuickSettingsSeatInterfaceIface;

#define QUICK_SETTINGS_TYPE_SEAT_INTERFACE_PROXY (quick_settings_seat_interface_proxy_get_type ())
enum  {
	QUICK_SETTINGS_USER_LIST_0_PROPERTY,
	QUICK_SETTINGS_USER_LIST_NUM_PROPERTIES
};
static GParamSpec* quick_settings_user_list_properties[QUICK_SETTINGS_USER_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block9Data Block9Data;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block10Data Block10Data;
enum  {
	QUICK_SETTINGS_USER_LIST_SWITCH_TO_GUEST_SIGNAL,
	QUICK_SETTINGS_USER_LIST_SWITCH_TO_USER_SIGNAL,
	QUICK_SETTINGS_USER_LIST_NUM_SIGNALS
};
static guint quick_settings_user_list_signals[QUICK_SETTINGS_USER_LIST_NUM_SIGNALS] = {0};

struct _QuickSettingsSeatInterfaceIface {
	GTypeInterface parent_iface;
	void (*switch_to_guest) (QuickSettingsSeatInterface* self, const gchar* session_name, GError** error);
	void (*switch_to_user) (QuickSettingsSeatInterface* self, const gchar* username, const gchar* session_name, GError** error);
	gboolean (*get_has_guest_account) (QuickSettingsSeatInterface* self);
};

struct _QuickSettingsUserListPrivate {
	QuickSettingsSeatInterface* dm_proxy;
	GeeHashMap* user_map;
	GtkListBox* listbox;
	GtkPopover* popover;
	GtkRevealer* user_list_revealer;
};

struct _Block9Data {
	int _ref_count_;
	QuickSettingsUserList* self;
	QuickSettingsCurrentUser* current_user;
	gchar* session_path;
};

struct _Block10Data {
	int _ref_count_;
	Block9Data * _data9_;
	QuickSettingsSessionInterface* session_interface;
};

static gint QuickSettingsUserList_private_offset;
static gpointer quick_settings_user_list_parent_class = NULL;

VALA_EXTERN GType quick_settings_seat_interface_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint quick_settings_seat_interface_register_object (void* object,
                                                     GDBusConnection* connection,
                                                     const gchar* path,
                                                     GError** error);
VALA_EXTERN GType quick_settings_seat_interface_get_type (void) G_GNUC_CONST ;
static uid_t* _uid_t_dup (uid_t* self);
static void quick_settings_user_list_init_users (QuickSettingsUserList* self);
static void quick_settings_user_list_add_user (QuickSettingsUserList* self,
                                        ActUser* user);
static void quick_settings_user_list_add_guest (QuickSettingsUserList* self);
static void quick_settings_user_list_remove_user (QuickSettingsUserList* self,
                                           ActUser* user);
static void quick_settings_user_list_update_user (QuickSettingsUserList* self,
                                           ActUser* user);
static void quick_settings_user_list_show_settings (QuickSettingsUserList* self);
static GObject * quick_settings_user_list_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static gint _quick_settings_user_list_sort_func_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                 GtkListBoxRow* row2,
                                                                 gpointer self);
static void _quick_settings_user_list____lambda10_ (QuickSettingsUserList* self);
static void __quick_settings_user_list____lambda10__g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static void _quick_settings_user_list_add_user_act_user_manager_user_added (ActUserManager* _sender,
                                                                     ActUser* user,
                                                                     gpointer self);
static void _quick_settings_user_list_remove_user_act_user_manager_user_removed (ActUserManager* _sender,
                                                                          ActUser* user,
                                                                          gpointer self);
static void _quick_settings_user_list_update_user_act_user_manager_user_changed (ActUserManager* _sender,
                                                                          ActUser* user,
                                                                          gpointer self);
VALA_EXTERN gboolean quick_settings_seat_interface_get_has_guest_account (QuickSettingsSeatInterface* self);
static void _quick_settings_user_list____lambda11_ (QuickSettingsUserList* self);
VALA_EXTERN void quick_settings_seat_interface_switch_to_guest (QuickSettingsSeatInterface* self,
                                                    const gchar* session_name,
                                                    GError** error);
static void __quick_settings_user_list____lambda11__quick_settings_user_list_switch_to_guest (QuickSettingsUserList* _sender,
                                                                                       gpointer self);
static void _quick_settings_user_list____lambda12_ (Block9Data* _data9_,
                                             const gchar* username);
VALA_EXTERN void quick_settings_seat_interface_switch_to_user (QuickSettingsSeatInterface* self,
                                                   const gchar* username,
                                                   const gchar* session_name,
                                                   GError** error);
static void __quick_settings_user_list____lambda12__quick_settings_user_list_switch_to_user (QuickSettingsUserList* _sender,
                                                                                      const gchar* username,
                                                                                      gpointer self);
static void _quick_settings_user_list___lambda13_ (QuickSettingsUserList* self,
                                            GtkListBoxRow* row);
static void __quick_settings_user_list___lambda13__gtk_list_box_row_activated (GtkListBox* _sender,
                                                                        GtkListBoxRow* row,
                                                                        gpointer self);
static void _quick_settings_user_list___lambda14_ (QuickSettingsUserList* self);
static void __quick_settings_user_list___lambda14__gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
static void _quick_settings_user_list___lambda15_ (QuickSettingsUserList* self);
static void __quick_settings_user_list___lambda15__gtk_widget_realize (GtkWidget* _sender,
                                                                gpointer self);
static void _quick_settings_user_list___lambda16_ (Block9Data* _data9_,
                                            GObject* obj,
                                            GAsyncResult* res);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void __lambda17_ (Block10Data* _data10_);
static void __lambda18_ (Block10Data* _data10_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda18__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void ___lambda17__quick_settings_current_user_logout (QuickSettingsCurrentUser* _sender,
                                                      gpointer self);
static void __quick_settings_user_list___lambda16__gasync_ready_callback (GObject* source_object,
                                                                   GAsyncResult* res,
                                                                   gpointer self);
static void quick_settings_user_list_finalize (GObject * obj);
static GType quick_settings_user_list_get_type_once (void);

static inline gpointer
quick_settings_user_list_get_instance_private (QuickSettingsUserList* self)
{
	return G_STRUCT_MEMBER_P (self, QuickSettingsUserList_private_offset);
}

static uid_t*
_uid_t_dup (uid_t* self)
{
	uid_t* dup;
	dup = g_new0 (uid_t, 1);
	memcpy (dup, self, sizeof (uid_t));
	return dup;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
quick_settings_user_list_init_users (QuickSettingsUserList* self)
{
	ActUserManager* _tmp0_;
	GSList* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = quick_settings_user_manager_get_usermanager ();
	_tmp1_ = act_user_manager_list_users (_tmp0_);
	{
		GSList* user_collection = NULL;
		GSList* user_it = NULL;
		user_collection = _tmp1_;
		for (user_it = user_collection; user_it != NULL; user_it = user_it->next) {
			ActUser* _tmp2_;
			ActUser* user = NULL;
			_tmp2_ = _g_object_ref0 ((ActUser*) user_it->data);
			user = _tmp2_;
			{
				ActUser* _tmp3_;
				_tmp3_ = user;
				quick_settings_user_list_add_user (self, _tmp3_);
				_g_object_unref0 (user);
			}
		}
		(user_collection == NULL) ? NULL : (user_collection = (g_slist_free (user_collection), NULL));
	}
}

static void
quick_settings_user_list_add_user (QuickSettingsUserList* self,
                                   ActUser* user)
{
	uid_t uid = 0;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	QuickSettingsUserRow* _tmp2_;
	QuickSettingsUserRow* _tmp3_;
	GeeHashMap* _tmp4_;
	gpointer _tmp5_;
	QuickSettingsUserRow* _tmp6_;
	GtkListBox* _tmp7_;
	GeeHashMap* _tmp8_;
	gpointer _tmp9_;
	QuickSettingsUserRow* _tmp10_;
	GtkRevealer* _tmp11_;
	GtkListBox* _tmp12_;
	GtkListBoxRow* _tmp13_;
	g_return_if_fail (self != NULL);
	if (act_user_is_system_account (user)) {
		return;
	}
	uid = act_user_get_uid (user);
	_tmp0_ = self->priv->user_map;
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, &uid)) {
		return;
	}
	if (quick_settings_user_manager_is_current_user (user)) {
		return;
	}
	_tmp1_ = self->priv->user_map;
	_tmp2_ = quick_settings_user_row_new (user);
	g_object_ref_sink (_tmp2_);
	_tmp3_ = _tmp2_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, &uid, _tmp3_);
	_g_object_unref0 (_tmp3_);
	_tmp4_ = self->priv->user_map;
	_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, &uid);
	_tmp6_ = (QuickSettingsUserRow*) _tmp5_;
	gtk_widget_show ((GtkWidget*) _tmp6_);
	_g_object_unref0 (_tmp6_);
	_tmp7_ = self->priv->listbox;
	_tmp8_ = self->priv->user_map;
	_tmp9_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp8_, &uid);
	_tmp10_ = (QuickSettingsUserRow*) _tmp9_;
	gtk_container_add ((GtkContainer*) _tmp7_, (GtkWidget*) _tmp10_);
	_g_object_unref0 (_tmp10_);
	_tmp11_ = self->priv->user_list_revealer;
	_tmp12_ = self->priv->listbox;
	_tmp13_ = gtk_list_box_get_row_at_index (_tmp12_, 0);
	gtk_revealer_set_reveal_child (_tmp11_, _tmp13_ != NULL);
}

static void
quick_settings_user_list_add_guest (QuickSettingsUserList* self)
{
	GeeHashMap* _tmp0_;
	uid_t _tmp1_;
	gpointer _tmp2_;
	QuickSettingsUserRow* _tmp3_;
	gboolean _tmp4_;
	ActUser* _tmp5_;
	ActUser* _tmp6_;
	gboolean _tmp7_;
	GeeHashMap* _tmp8_;
	uid_t _tmp9_;
	QuickSettingsUserRow* _tmp10_;
	QuickSettingsUserRow* _tmp11_;
	GeeHashMap* _tmp12_;
	uid_t _tmp13_;
	gpointer _tmp14_;
	QuickSettingsUserRow* _tmp15_;
	GtkListBox* _tmp16_;
	GeeHashMap* _tmp17_;
	uid_t _tmp18_;
	gpointer _tmp19_;
	QuickSettingsUserRow* _tmp20_;
	GtkRevealer* _tmp21_;
	GtkListBox* _tmp22_;
	GtkListBoxRow* _tmp23_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->user_map;
	_tmp1_ = QUICK_SETTINGS_USER_LIST_GUEST_USER_UID;
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, &_tmp1_);
	_tmp3_ = (QuickSettingsUserRow*) _tmp2_;
	_tmp4_ = _tmp3_ != NULL;
	_g_object_unref0 (_tmp3_);
	if (_tmp4_) {
		return;
	}
	_tmp5_ = quick_settings_user_manager_get_current_user ();
	_tmp6_ = _tmp5_;
	_tmp7_ = _tmp6_ == NULL;
	_g_object_unref0 (_tmp6_);
	if (_tmp7_) {
		return;
	}
	_tmp8_ = self->priv->user_map;
	_tmp9_ = QUICK_SETTINGS_USER_LIST_GUEST_USER_UID;
	_tmp10_ = quick_settings_user_row_new_guest ();
	g_object_ref_sink (_tmp10_);
	_tmp11_ = _tmp10_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp8_, &_tmp9_, _tmp11_);
	_g_object_unref0 (_tmp11_);
	_tmp12_ = self->priv->user_map;
	_tmp13_ = QUICK_SETTINGS_USER_LIST_GUEST_USER_UID;
	_tmp14_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp12_, &_tmp13_);
	_tmp15_ = (QuickSettingsUserRow*) _tmp14_;
	gtk_widget_show ((GtkWidget*) _tmp15_);
	_g_object_unref0 (_tmp15_);
	_tmp16_ = self->priv->listbox;
	_tmp17_ = self->priv->user_map;
	_tmp18_ = QUICK_SETTINGS_USER_LIST_GUEST_USER_UID;
	_tmp19_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp17_, &_tmp18_);
	_tmp20_ = (QuickSettingsUserRow*) _tmp19_;
	gtk_container_add ((GtkContainer*) _tmp16_, (GtkWidget*) _tmp20_);
	_g_object_unref0 (_tmp20_);
	_tmp21_ = self->priv->user_list_revealer;
	_tmp22_ = self->priv->listbox;
	_tmp23_ = gtk_list_box_get_row_at_index (_tmp22_, 0);
	gtk_revealer_set_reveal_child (_tmp21_, _tmp23_ != NULL);
}

static void
quick_settings_user_list_remove_user (QuickSettingsUserList* self,
                                      ActUser* user)
{
	uid_t uid = 0;
	QuickSettingsUserRow* user_row = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	QuickSettingsUserRow* _tmp2_;
	GeeHashMap* _tmp3_;
	GtkListBox* _tmp4_;
	QuickSettingsUserRow* _tmp5_;
	GtkListBox* _tmp6_;
	GtkRevealer* _tmp7_;
	GtkListBox* _tmp8_;
	GtkListBoxRow* _tmp9_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (user != NULL);
	uid = act_user_get_uid (user);
	_tmp0_ = self->priv->user_map;
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, &uid);
	user_row = (QuickSettingsUserRow*) _tmp1_;
	_tmp2_ = user_row;
	if (_tmp2_ == NULL) {
		_g_object_unref0 (user_row);
		return;
	}
	_tmp3_ = self->priv->user_map;
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp3_, &uid, NULL);
	_tmp4_ = self->priv->listbox;
	_tmp5_ = user_row;
	gtk_container_remove ((GtkContainer*) _tmp4_, (GtkWidget*) _tmp5_);
	_tmp6_ = self->priv->listbox;
	gtk_list_box_invalidate_sort (_tmp6_);
	_tmp7_ = self->priv->user_list_revealer;
	_tmp8_ = self->priv->listbox;
	_tmp9_ = gtk_list_box_get_row_at_index (_tmp8_, 0);
	gtk_revealer_set_reveal_child (_tmp7_, _tmp9_ != NULL);
	_g_object_unref0 (user_row);
}

static void
quick_settings_user_list_update_user (QuickSettingsUserList* self,
                                      ActUser* user)
{
	QuickSettingsUserRow* userbox = NULL;
	GeeHashMap* _tmp0_;
	uid_t _tmp1_;
	gpointer _tmp2_;
	QuickSettingsUserRow* _tmp3_;
	QuickSettingsUserRow* _tmp4_;
	GtkRevealer* _tmp5_;
	GtkListBox* _tmp6_;
	GtkListBoxRow* _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (user != NULL);
	_tmp0_ = self->priv->user_map;
	_tmp1_ = act_user_get_uid (user);
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, &_tmp1_);
	userbox = (QuickSettingsUserRow*) _tmp2_;
	_tmp3_ = userbox;
	if (_tmp3_ == NULL) {
		_g_object_unref0 (userbox);
		return;
	}
	_tmp4_ = userbox;
	quick_settings_user_row_update_state (_tmp4_, NULL, NULL);
	_tmp5_ = self->priv->user_list_revealer;
	_tmp6_ = self->priv->listbox;
	_tmp7_ = gtk_list_box_get_row_at_index (_tmp6_, 0);
	gtk_revealer_set_reveal_child (_tmp5_, _tmp7_ != NULL);
	_g_object_unref0 (userbox);
}

void
quick_settings_user_list_update_all (QuickSettingsUserList* self)
{
	g_return_if_fail (self != NULL);
	{
		GeeIterator* _row_it = NULL;
		GeeHashMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp0_ = self->priv->user_map;
		_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_row_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			QuickSettingsUserRow* row = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			QuickSettingsUserRow* _tmp9_;
			_tmp6_ = _row_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _row_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			row = (QuickSettingsUserRow*) _tmp8_;
			_tmp9_ = row;
			quick_settings_user_row_update_state (_tmp9_, NULL, NULL);
			_g_object_unref0 (row);
		}
		_g_object_unref0 (_row_it);
	}
}

gint
quick_settings_user_list_sort_func (QuickSettingsUserList* self,
                                    GtkListBoxRow* row1,
                                    GtkListBoxRow* row2)
{
	QuickSettingsUserRow* userbox1 = NULL;
	QuickSettingsUserRow* _tmp0_;
	QuickSettingsUserRow* userbox2 = NULL;
	QuickSettingsUserRow* _tmp1_;
	gboolean _tmp2_ = FALSE;
	QuickSettingsUserRow* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	QuickSettingsUserRow* _tmp16_;
	ActUser* _tmp17_;
	ActUser* _tmp18_;
	QuickSettingsUserRow* _tmp19_;
	ActUser* _tmp20_;
	ActUser* _tmp21_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (row1 != NULL, 0);
	g_return_val_if_fail (row2 != NULL, 0);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (row1, QUICK_SETTINGS_TYPE_USER_ROW, QuickSettingsUserRow));
	userbox1 = _tmp0_;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (row2, QUICK_SETTINGS_TYPE_USER_ROW, QuickSettingsUserRow));
	userbox2 = _tmp1_;
	_tmp3_ = userbox1;
	_tmp4_ = quick_settings_user_row_get_is_guest (_tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		QuickSettingsUserRow* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp6_ = userbox2;
		_tmp7_ = quick_settings_user_row_get_is_guest (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp2_ = !_tmp8_;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		result = 1;
		_g_object_unref0 (userbox2);
		_g_object_unref0 (userbox1);
		return result;
	} else {
		gboolean _tmp9_ = FALSE;
		QuickSettingsUserRow* _tmp10_;
		gboolean _tmp11_;
		gboolean _tmp12_;
		_tmp10_ = userbox1;
		_tmp11_ = quick_settings_user_row_get_is_guest (_tmp10_);
		_tmp12_ = _tmp11_;
		if (!_tmp12_) {
			QuickSettingsUserRow* _tmp13_;
			gboolean _tmp14_;
			gboolean _tmp15_;
			_tmp13_ = userbox2;
			_tmp14_ = quick_settings_user_row_get_is_guest (_tmp13_);
			_tmp15_ = _tmp14_;
			_tmp9_ = _tmp15_;
		} else {
			_tmp9_ = FALSE;
		}
		if (_tmp9_) {
			result = -1;
			_g_object_unref0 (userbox2);
			_g_object_unref0 (userbox1);
			return result;
		}
	}
	_tmp16_ = userbox1;
	_tmp17_ = quick_settings_user_row_get_user (_tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = userbox2;
	_tmp20_ = quick_settings_user_row_get_user (_tmp19_);
	_tmp21_ = _tmp20_;
	result = act_user_collate (_tmp18_, _tmp21_);
	_g_object_unref0 (userbox2);
	_g_object_unref0 (userbox1);
	return result;
}

static void
quick_settings_user_list_show_settings (QuickSettingsUserList* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		g_app_info_launch_default_for_uri ("settings://accounts", NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp0_ = e;
		_tmp1_ = _tmp0_->message;
		g_warning ("UserList.vala:236: %s\n", _tmp1_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

QuickSettingsUserList*
quick_settings_user_list_construct (GType object_type)
{
	QuickSettingsUserList * self = NULL;
	self = (QuickSettingsUserList*) g_object_new (object_type, NULL);
	return self;
}

QuickSettingsUserList*
quick_settings_user_list_new (void)
{
	return quick_settings_user_list_construct (QUICK_SETTINGS_TYPE_USER_LIST);
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
	g_atomic_int_inc (&_data9_->_ref_count_);
	return _data9_;
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
		QuickSettingsUserList* self;
		self = _data9_->self;
		_g_free0 (_data9_->session_path);
		_g_object_unref0 (_data9_->current_user);
		_g_object_unref0 (self);
		g_slice_free (Block9Data, _data9_);
	}
}

static gint
_quick_settings_user_list_sort_func_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                            GtkListBoxRow* row2,
                                                            gpointer self)
{
	gint result;
	result = quick_settings_user_list_sort_func ((QuickSettingsUserList*) self, row1, row2);
	return result;
}

static void
_quick_settings_user_list____lambda10_ (QuickSettingsUserList* self)
{
	quick_settings_user_list_init_users (self);
}

static void
__quick_settings_user_list____lambda10__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
	_quick_settings_user_list____lambda10_ ((QuickSettingsUserList*) self);
}

static void
_quick_settings_user_list_add_user_act_user_manager_user_added (ActUserManager* _sender,
                                                                ActUser* user,
                                                                gpointer self)
{
	quick_settings_user_list_add_user ((QuickSettingsUserList*) self, user);
}

static void
_quick_settings_user_list_remove_user_act_user_manager_user_removed (ActUserManager* _sender,
                                                                     ActUser* user,
                                                                     gpointer self)
{
	quick_settings_user_list_remove_user ((QuickSettingsUserList*) self, user);
}

static void
_quick_settings_user_list_update_user_act_user_manager_user_changed (ActUserManager* _sender,
                                                                     ActUser* user,
                                                                     gpointer self)
{
	quick_settings_user_list_update_user ((QuickSettingsUserList*) self, user);
}

static void
_quick_settings_user_list____lambda11_ (QuickSettingsUserList* self)
{
	GError* _inner_error0_ = NULL;
	{
		QuickSettingsSeatInterface* _tmp0_;
		_tmp0_ = self->priv->dm_proxy;
		quick_settings_seat_interface_switch_to_guest (_tmp0_, "", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = e;
		_tmp2_ = _tmp1_->message;
		g_warning ("UserList.vala:87: Error switching to guest account: %s", _tmp2_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
__quick_settings_user_list____lambda11__quick_settings_user_list_switch_to_guest (QuickSettingsUserList* _sender,
                                                                                  gpointer self)
{
	_quick_settings_user_list____lambda11_ ((QuickSettingsUserList*) self);
}

static void
_quick_settings_user_list____lambda12_ (Block9Data* _data9_,
                                        const gchar* username)
{
	QuickSettingsUserList* self;
	GError* _inner_error0_ = NULL;
	self = _data9_->self;
	g_return_if_fail (username != NULL);
	{
		QuickSettingsSeatInterface* _tmp0_;
		const gchar* _tmp1_;
		_tmp0_ = self->priv->dm_proxy;
		_tmp1_ = _data9_->session_path;
		quick_settings_seat_interface_switch_to_user (_tmp0_, username, _tmp1_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp2_ = e;
		_tmp3_ = _tmp2_->message;
		g_warning ("UserList.vala:95: Error switching to user '%s': %s", username, _tmp3_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
__quick_settings_user_list____lambda12__quick_settings_user_list_switch_to_user (QuickSettingsUserList* _sender,
                                                                                 const gchar* username,
                                                                                 gpointer self)
{
	_quick_settings_user_list____lambda12_ (self, username);
}

static void
_quick_settings_user_list___lambda13_ (QuickSettingsUserList* self,
                                       GtkListBoxRow* row)
{
	QuickSettingsUserRow* userbox = NULL;
	QuickSettingsUserRow* _tmp0_;
	QuickSettingsUserRow* _tmp1_;
	GtkPopover* _tmp2_;
	QuickSettingsUserRow* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	g_return_if_fail (row != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (row, QUICK_SETTINGS_TYPE_USER_ROW, QuickSettingsUserRow));
	userbox = _tmp0_;
	_tmp1_ = userbox;
	if (_tmp1_ == NULL) {
		_g_object_unref0 (userbox);
		return;
	}
	_tmp2_ = self->priv->popover;
	gtk_popover_popdown (_tmp2_);
	_tmp3_ = userbox;
	_tmp4_ = quick_settings_user_row_get_is_guest (_tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		g_signal_emit (self, quick_settings_user_list_signals[QUICK_SETTINGS_USER_LIST_SWITCH_TO_GUEST_SIGNAL], 0);
	} else {
		ActUser* user = NULL;
		QuickSettingsUserRow* _tmp6_;
		ActUser* _tmp7_;
		ActUser* _tmp8_;
		ActUser* _tmp9_;
		ActUser* _tmp10_;
		_tmp6_ = userbox;
		_tmp7_ = quick_settings_user_row_get_user (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = _g_object_ref0 (_tmp8_);
		user = _tmp9_;
		_tmp10_ = user;
		if (_tmp10_ != NULL) {
			ActUser* _tmp11_;
			const gchar* _tmp12_;
			_tmp11_ = user;
			_tmp12_ = act_user_get_user_name (_tmp11_);
			g_signal_emit (self, quick_settings_user_list_signals[QUICK_SETTINGS_USER_LIST_SWITCH_TO_USER_SIGNAL], 0, _tmp12_);
		}
		_g_object_unref0 (user);
	}
	_g_object_unref0 (userbox);
}

static void
__quick_settings_user_list___lambda13__gtk_list_box_row_activated (GtkListBox* _sender,
                                                                   GtkListBoxRow* row,
                                                                   gpointer self)
{
	_quick_settings_user_list___lambda13_ ((QuickSettingsUserList*) self, row);
}

static void
_quick_settings_user_list___lambda14_ (QuickSettingsUserList* self)
{
	quick_settings_user_list_show_settings (self);
}

static void
__quick_settings_user_list___lambda14__gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
	_quick_settings_user_list___lambda14_ ((QuickSettingsUserList*) self);
}

static void
_quick_settings_user_list___lambda15_ (QuickSettingsUserList* self)
{
	GtkWidget* _tmp0_;
	GtkPopover* _tmp1_;
	_tmp0_ = gtk_widget_get_ancestor ((GtkWidget*) self, gtk_popover_get_type ());
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_popover_get_type (), GtkPopover));
	_g_object_unref0 (self->priv->popover);
	self->priv->popover = _tmp1_;
}

static void
__quick_settings_user_list___lambda15__gtk_widget_realize (GtkWidget* _sender,
                                                           gpointer self)
{
	_quick_settings_user_list___lambda15_ ((QuickSettingsUserList*) self);
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
	g_atomic_int_inc (&_data10_->_ref_count_);
	return _data10_;
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
		QuickSettingsUserList* self;
		self = _data10_->_data9_->self;
		_g_object_unref0 (_data10_->session_interface);
		block9_data_unref (_data10_->_data9_);
		_data10_->_data9_ = NULL;
		g_slice_free (Block10Data, _data10_);
	}
}

static void
__lambda18_ (Block10Data* _data10_,
             GObject* obj,
             GAsyncResult* res)
{
	Block9Data* _data9_;
	QuickSettingsUserList* self;
	GError* _inner_error0_ = NULL;
	_data9_ = _data10_->_data9_;
	self = _data9_->self;
	g_return_if_fail (res != NULL);
	{
		QuickSettingsSessionInterface* _tmp0_;
		_tmp0_ = _data10_->session_interface;
		quick_settings_session_interface_logout_finish (_tmp0_, res, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = e;
		if (!g_error_matches (_tmp1_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
			GError* _tmp2_;
			const gchar* _tmp3_;
			_tmp2_ = e;
			_tmp3_ = _tmp2_->message;
			g_warning ("UserList.vala:137: Unable to open logout dialog: %s", _tmp3_);
		}
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
___lambda18__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda18_ (self, source_object, res);
	block10_data_unref (self);
}

static void
__lambda17_ (Block10Data* _data10_)
{
	Block9Data* _data9_;
	QuickSettingsUserList* self;
	GtkPopover* _tmp0_;
	QuickSettingsSessionInterface* _tmp1_;
	_data9_ = _data10_->_data9_;
	self = _data9_->self;
	_tmp0_ = self->priv->popover;
	gtk_popover_popdown (_tmp0_);
	_tmp1_ = _data10_->session_interface;
	quick_settings_session_interface_logout (_tmp1_, (guint) 0, ___lambda18__gasync_ready_callback, block10_data_ref (_data10_));
}

static void
___lambda17__quick_settings_current_user_logout (QuickSettingsCurrentUser* _sender,
                                                 gpointer self)
{
	__lambda17_ (self);
}

static void
_quick_settings_user_list___lambda16_ (Block9Data* _data9_,
                                       GObject* obj,
                                       GAsyncResult* res)
{
	QuickSettingsUserList* self;
	Block10Data* _data10_;
	QuickSettingsSessionInterface* _tmp0_;
	QuickSettingsCurrentUser* _tmp1_;
	self = _data9_->self;
	g_return_if_fail (res != NULL);
	_data10_ = g_slice_new0 (Block10Data);
	_data10_->_ref_count_ = 1;
	_data10_->_data9_ = block9_data_ref (_data9_);
	_tmp0_ = quick_settings_user_manager_setup_session_interface_finish (res);
	_data10_->session_interface = _tmp0_;
	_tmp1_ = _data9_->current_user;
	g_signal_connect_data (_tmp1_, "logout", (GCallback) ___lambda17__quick_settings_current_user_logout, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
	block10_data_unref (_data10_);
	_data10_ = NULL;
}

static void
__quick_settings_user_list___lambda16__gasync_ready_callback (GObject* source_object,
                                                              GAsyncResult* res,
                                                              gpointer self)
{
	_quick_settings_user_list___lambda16_ (self, source_object, res);
	block9_data_unref (self);
}

static GObject *
quick_settings_user_list_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	QuickSettingsUserList * self;
	Block9Data* _data9_;
	QuickSettingsCurrentUser* _tmp0_;
	GtkListBox* _tmp1_ = NULL;
	GtkListBox* _tmp2_;
	GtkScrolledWindow* listbox_scrolled = NULL;
	GtkListBox* _tmp3_;
	GtkWidget* _tmp4_;
	GtkScrolledWindow* _tmp5_ = NULL;
	GtkModelButton* settings_button = NULL;
	gchar* _tmp6_;
	GtkModelButton* _tmp7_ = NULL;
	GtkBox* user_list_vbox = NULL;
	GtkBox* _tmp8_;
	GtkBox* _tmp9_;
	GtkSeparator* _tmp10_;
	GtkSeparator* _tmp11_;
	GtkBox* _tmp12_;
	GtkScrolledWindow* _tmp13_;
	GtkBox* _tmp14_;
	GtkWidget* _tmp15_;
	GtkRevealer* _tmp16_ = NULL;
	QuickSettingsCurrentUser* _tmp17_;
	GtkRevealer* _tmp18_;
	GtkSeparator* _tmp19_;
	GtkSeparator* _tmp20_;
	GtkModelButton* _tmp21_;
	ActUserManager* _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	ActUserManager* _tmp26_;
	ActUserManager* _tmp27_;
	ActUserManager* _tmp28_;
	gchar* seat_path = NULL;
	const gchar* _tmp29_;
	gchar* _tmp30_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	const gchar* _tmp33_;
	QuickSettingsSeatInterface* _tmp46_;
	GtkListBox* _tmp47_;
	GtkModelButton* _tmp48_;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (quick_settings_user_list_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, QUICK_SETTINGS_TYPE_USER_LIST, QuickSettingsUserList);
	_data9_ = g_slice_new0 (Block9Data);
	_data9_->_ref_count_ = 1;
	_data9_->self = g_object_ref (self);
	_tmp0_ = quick_settings_current_user_new ();
	g_object_ref_sink (_tmp0_);
	_data9_->current_user = _tmp0_;
	_tmp1_ = (GtkListBox*) gtk_list_box_new ();
	gtk_widget_set_hexpand ((GtkWidget*) _tmp1_, TRUE);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->listbox);
	self->priv->listbox = _tmp1_;
	_tmp2_ = self->priv->listbox;
	gtk_list_box_set_sort_func (_tmp2_, _quick_settings_user_list_sort_func_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
	_tmp3_ = self->priv->listbox;
	_tmp4_ = _g_object_ref0 ((GtkWidget*) _tmp3_);
	_tmp5_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_set (_tmp5_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
	gtk_scrolled_window_set_max_content_height (_tmp5_, 200);
	gtk_scrolled_window_set_propagate_natural_height (_tmp5_, TRUE);
	g_object_set ((GtkContainer*) _tmp5_, "child", _tmp4_, NULL);
	_g_object_unref0 (_tmp4_);
	g_object_ref_sink (_tmp5_);
	listbox_scrolled = _tmp5_;
	_tmp6_ = g_strdup (_ ("User Accounts Settings…"));
	_tmp7_ = (GtkModelButton*) gtk_model_button_new ();
	g_object_set (_tmp7_, "text", _tmp6_, NULL);
	_g_free0 (_tmp6_);
	g_object_ref_sink (_tmp7_);
	settings_button = _tmp7_;
	_tmp8_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp8_);
	user_list_vbox = _tmp8_;
	_tmp9_ = user_list_vbox;
	_tmp10_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp10_);
	_tmp11_ = _tmp10_;
	gtk_container_add ((GtkContainer*) _tmp9_, (GtkWidget*) _tmp11_);
	_g_object_unref0 (_tmp11_);
	_tmp12_ = user_list_vbox;
	_tmp13_ = listbox_scrolled;
	gtk_container_add ((GtkContainer*) _tmp12_, (GtkWidget*) _tmp13_);
	_tmp14_ = user_list_vbox;
	_tmp15_ = _g_object_ref0 ((GtkWidget*) _tmp14_);
	_tmp16_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_set ((GtkContainer*) _tmp16_, "child", _tmp15_, NULL);
	_g_object_unref0 (_tmp15_);
	gtk_revealer_set_reveal_child (_tmp16_, FALSE);
	g_object_ref_sink (_tmp16_);
	_g_object_unref0 (self->priv->user_list_revealer);
	self->priv->user_list_revealer = _tmp16_;
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
	_tmp17_ = _data9_->current_user;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp17_);
	_tmp18_ = self->priv->user_list_revealer;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp18_);
	_tmp19_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp19_);
	_tmp20_ = _tmp19_;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp20_);
	_g_object_unref0 (_tmp20_);
	_tmp21_ = settings_button;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp21_);
	_tmp22_ = quick_settings_user_manager_get_usermanager ();
	g_object_get (_tmp22_, "is-loaded", &_tmp23_, NULL);
	_tmp24_ = _tmp23_;
	if (_tmp24_) {
		quick_settings_user_list_init_users (self);
	} else {
		ActUserManager* _tmp25_;
		_tmp25_ = quick_settings_user_manager_get_usermanager ();
		g_signal_connect_object ((GObject*) _tmp25_, "notify::is-loaded", (GCallback) __quick_settings_user_list____lambda10__g_object_notify, self, 0);
	}
	_tmp26_ = quick_settings_user_manager_get_usermanager ();
	g_signal_connect_object (_tmp26_, "user-added", (GCallback) _quick_settings_user_list_add_user_act_user_manager_user_added, self, 0);
	_tmp27_ = quick_settings_user_manager_get_usermanager ();
	g_signal_connect_object (_tmp27_, "user-removed", (GCallback) _quick_settings_user_list_remove_user_act_user_manager_user_removed, self, 0);
	_tmp28_ = quick_settings_user_manager_get_usermanager ();
	g_signal_connect_object (_tmp28_, "user-changed", (GCallback) _quick_settings_user_list_update_user_act_user_manager_user_changed, self, 0);
	_tmp29_ = g_getenv ("XDG_SEAT_PATH");
	_tmp30_ = g_strdup (_tmp29_);
	seat_path = _tmp30_;
	_tmp31_ = g_getenv ("XDG_SESSION_PATH");
	_tmp32_ = g_strdup (_tmp31_);
	_data9_->session_path = _tmp32_;
	_tmp33_ = seat_path;
	if (_tmp33_ != NULL) {
		{
			QuickSettingsSeatInterface* _tmp34_ = NULL;
			const gchar* _tmp35_;
			QuickSettingsSeatInterface* _tmp36_;
			QuickSettingsSeatInterface* _tmp37_;
			gboolean _tmp38_ = FALSE;
			QuickSettingsSeatInterface* _tmp39_;
			gboolean _tmp40_;
			gboolean _tmp41_;
			_tmp35_ = seat_path;
			_tmp36_ = (QuickSettingsSeatInterface*) g_initable_new (QUICK_SETTINGS_TYPE_SEAT_INTERFACE_PROXY, NULL, &_inner_error0_, "g-flags", G_DBUS_PROXY_FLAGS_NONE, "g-name", QUICK_SETTINGS_USER_LIST_DM_DBUS_ID, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", _tmp35_, "g-interface-name", "org.freedesktop.DisplayManager.Seat", NULL);
			_tmp34_ = (QuickSettingsSeatInterface*) _tmp36_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == G_IO_ERROR) {
					goto __catch0_g_io_error;
				}
				_g_free0 (seat_path);
				_g_object_unref0 (user_list_vbox);
				_g_object_unref0 (settings_button);
				_g_object_unref0 (listbox_scrolled);
				block9_data_unref (_data9_);
				_data9_ = NULL;
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
			}
			_tmp37_ = _tmp34_;
			_tmp34_ = NULL;
			_g_object_unref0 (self->priv->dm_proxy);
			self->priv->dm_proxy = _tmp37_;
			_tmp39_ = self->priv->dm_proxy;
			_tmp40_ = quick_settings_seat_interface_get_has_guest_account (_tmp39_);
			_tmp41_ = _tmp40_;
			if (_tmp41_) {
				ActUser* _tmp42_;
				ActUser* _tmp43_;
				_tmp42_ = quick_settings_user_manager_get_current_user ();
				_tmp43_ = _tmp42_;
				_tmp38_ = _tmp43_ != NULL;
				_g_object_unref0 (_tmp43_);
			} else {
				_tmp38_ = FALSE;
			}
			if (_tmp38_) {
				quick_settings_user_list_add_guest (self);
			}
			_g_object_unref0 (_tmp34_);
		}
		goto __finally0;
		__catch0_g_io_error:
		{
			GError* e = NULL;
			GError* _tmp44_;
			const gchar* _tmp45_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp44_ = e;
			_tmp45_ = _tmp44_->message;
			g_critical ("UserList.vala:78: UserManager error: %s", _tmp45_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (seat_path);
			_g_object_unref0 (user_list_vbox);
			_g_object_unref0 (settings_button);
			_g_object_unref0 (listbox_scrolled);
			block9_data_unref (_data9_);
			_data9_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
		}
	}
	_tmp46_ = self->priv->dm_proxy;
	if (_tmp46_ != NULL) {
		g_signal_connect_object (self, "switch-to-guest", (GCallback) __quick_settings_user_list____lambda11__quick_settings_user_list_switch_to_guest, self, 0);
		g_signal_connect_data (self, "switch-to-user", (GCallback) __quick_settings_user_list____lambda12__quick_settings_user_list_switch_to_user, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
	}
	_tmp47_ = self->priv->listbox;
	g_signal_connect_object (_tmp47_, "row-activated", (GCallback) __quick_settings_user_list___lambda13__gtk_list_box_row_activated, self, 0);
	_tmp48_ = settings_button;
	g_signal_connect_object ((GtkButton*) _tmp48_, "clicked", (GCallback) __quick_settings_user_list___lambda14__gtk_button_clicked, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "realize", (GCallback) __quick_settings_user_list___lambda15__gtk_widget_realize, self, 0);
	quick_settings_user_manager_setup_session_interface (__quick_settings_user_list___lambda16__gasync_ready_callback, block9_data_ref (_data9_));
	_g_free0 (seat_path);
	_g_object_unref0 (user_list_vbox);
	_g_object_unref0 (settings_button);
	_g_object_unref0 (listbox_scrolled);
	block9_data_unref (_data9_);
	_data9_ = NULL;
	return obj;
}

static void
quick_settings_user_list_class_init (QuickSettingsUserListClass * klass,
                                     gpointer klass_data)
{
	quick_settings_user_list_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &QuickSettingsUserList_private_offset);
	G_OBJECT_CLASS (klass)->constructor = quick_settings_user_list_constructor;
	G_OBJECT_CLASS (klass)->finalize = quick_settings_user_list_finalize;
	quick_settings_user_list_signals[QUICK_SETTINGS_USER_LIST_SWITCH_TO_GUEST_SIGNAL] = g_signal_new ("switch-to-guest", QUICK_SETTINGS_TYPE_USER_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	quick_settings_user_list_signals[QUICK_SETTINGS_USER_LIST_SWITCH_TO_USER_SIGNAL] = g_signal_new ("switch-to-user", QUICK_SETTINGS_TYPE_USER_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
}

static void
quick_settings_user_list_instance_init (QuickSettingsUserList * self,
                                        gpointer klass)
{
	GeeHashMap* _tmp0_;
	self->priv = quick_settings_user_list_get_instance_private (self);
	self->priv->dm_proxy = NULL;
	_tmp0_ = gee_hash_map_new (G_TYPE_INVALID, (GBoxedCopyFunc) _uid_t_dup, (GDestroyNotify) g_free, QUICK_SETTINGS_TYPE_USER_ROW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->user_map = _tmp0_;
}

static void
quick_settings_user_list_finalize (GObject * obj)
{
	QuickSettingsUserList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, QUICK_SETTINGS_TYPE_USER_LIST, QuickSettingsUserList);
	_g_object_unref0 (self->priv->dm_proxy);
	_g_object_unref0 (self->priv->user_map);
	_g_object_unref0 (self->priv->listbox);
	_g_object_unref0 (self->priv->popover);
	_g_object_unref0 (self->priv->user_list_revealer);
	G_OBJECT_CLASS (quick_settings_user_list_parent_class)->finalize (obj);
}

static GType
quick_settings_user_list_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (QuickSettingsUserListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) quick_settings_user_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (QuickSettingsUserList), 0, (GInstanceInitFunc) quick_settings_user_list_instance_init, NULL };
	GType quick_settings_user_list_type_id;
	quick_settings_user_list_type_id = g_type_register_static (gtk_box_get_type (), "QuickSettingsUserList", &g_define_type_info, 0);
	QuickSettingsUserList_private_offset = g_type_add_instance_private (quick_settings_user_list_type_id, sizeof (QuickSettingsUserListPrivate));
	return quick_settings_user_list_type_id;
}

GType
quick_settings_user_list_get_type (void)
{
	static volatile gsize quick_settings_user_list_type_id__once = 0;
	if (g_once_init_enter (&quick_settings_user_list_type_id__once)) {
		GType quick_settings_user_list_type_id;
		quick_settings_user_list_type_id = quick_settings_user_list_get_type_once ();
		g_once_init_leave (&quick_settings_user_list_type_id__once, quick_settings_user_list_type_id);
	}
	return quick_settings_user_list_type_id__once;
}

